fediverser/apps/core/urls.py
from django.urls import path

from . import views

app_name = "fediverser-core"

urlpatterns = [
    path("", views.HomeView.as_view(), name="portal-home"),
    path(
        "reddit/invites/<str:key>/accept",
        views.RedditorAcceptInviteView.as_view(),
        name="redditor-accept-invite",
    ),
    path(
        "reddit/invites/<str:key>/decline",
        views.RedditorDeclineInviteView.as_view(),
        name="redditor-decline-invite",
    ),
    path("reddit/connect", views.RedditConnectionView.as_view(), name="reddit-connection-setup"),
    path("reddit/login", views.RedditLoginView.as_view(), name="reddit-login"),
    path("lemmy/connect", views.LemmySignupView.as_view(), name="lemmy-connect-setup"),
    path("lemmy/set-password", views.LemmySetPasswordView.as_view(), name="lemmy-set-password"),
    path("activity", views.UserActionListView.as_view(), name="activity-list"),
    path("instances", views.InstanceListView.as_view(), name="instance-list"),
    path("instances/create", views.InstanceCreateView.as_view(), name="instance-create"),
    path("instances/find", views.InstanceFinderView.as_view(), name="instance-find"),
    path("instances/<str:domain>", views.InstanceDetailView.as_view(), name="instance-detail"),
    path(
        "instances/<str:domain>/recommend/category",
        views.InstanceCategoryRecommendationCreateView.as_view(),
        name="instance-categoryrecommendation-create",
    ),
    path(
        "instances/<str:domain>/recommend/country",
        views.InstanceCountryRecommendationCreateView.as_view(),
        name="instance-countryrecommendation-create",
    ),
    path(
        "instances/<str:domain>/annotate/closed",
        views.InstanceClosedAnnotationCreateView.as_view(),
        name="instance-closedannotation-create",
    ),
    path(
        "instances/<str:domain>/annotate/abandoned",
        views.InstanceAbandonedAnnotationCreateView.as_view(),
        name="instance-abandonedannotation-create",
    ),
    path("communities", views.CommunityListView.as_view(), name="community-list"),
    path(
        "communities/create",
        views.CommunityCreateView.as_view(),
        name="community-create",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>",
        views.CommunityDetailView.as_view(),
        name="community-detail",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>/repost/reddit",
        views.CommunityRepostRedditSubmissionView.as_view(),
        name="community-repost-reddit",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>/recommend/category",
        views.CommunityCategoryRecommendationCreateView.as_view(),
        name="community-categoryrecommendation-create",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>/ambassadors/apply",
        views.CommunityAmbassadorApplicationCreateView.as_view(),
        name="community-ambassador-application-create",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>/feeds/create",
        views.CommunityFeedCreateView.as_view(),
        name="community-contentfeed-create",
    ),
    path(
        "reddit/submissions/<str:submission_id>",
        views.RedditSubmissionView.as_view(),
        name="redditsubmission-detail",
    ),
    path("subreddits", views.SubredditListView.as_view(), name="subreddit-list"),
    path("subreddits/create", views.SubredditCreateView.as_view(), name="subreddit-create"),
    path("subreddits/<str:name>", views.SubredditDetailView.as_view(), name="subreddit-detail"),
    path(
        "subreddits/<str:name>/subscribe", views.subscribe_to_subreddit, name="subreddit-subscribe"
    ),
    path(
        "subreddits/<str:name>/unsubscribe",
        views.unsubscribe_from_subreddit,
        name="subreddit-unsubscribe",
    ),
    path(
        "subreddits/<str:name>/recommend/category",
        views.SubredditCategoryRecommendationCreateView.as_view(),
        name="subreddit-categoryrecommendation-create",
    ),
    path(
        "subreddits/<str:name>/recommend/alternative",
        views.SubredditAlternativeRecommendationCreateView.as_view(),
        name="subreddit-alternativerecommendation-create",
    ),
    path(
        "subreddits/<str:name>/request/community",
        views.CommunityRequestCreateView.as_view(),
        name="subreddit-communityrequest-create",
    ),
    path("redditors", views.RedditorListView.as_view(), name="redditor-list"),
    path("redditors/<str:username>", views.RedditorDetailView.as_view(), name="redditor-detail"),
    path(
        "redditors/<str:username>/invite",
        views.RedditorInviteView.as_view(),
        name="redditor-send-invite",
    ),
    path(
        "api/community-requests",
        views.CommunityRequestListView.as_view(),
        name="api-community-request-list",
    ),
    path(
        "api/subreddits",
        views.RedditCommunityListView.as_view(),
        name="api-subreddit-list",
    ),
    path("api/nodeinfo", views.NodeInfoView.as_view(), name="nodeinfo-detail"),
    path(
        "api/fediverser-instances",
        views.FediversedInstanceListView.as_view(),
        name="fediverserinstance-list",
    ),
    path(
        "api/instance/recommendations",
        views.InstanceRecommendationsListView.as_view(),
        name="api-instancerecommendation-list",
    ),
    path(
        "api/changes",
        views.ChangeFeedEntryListView.as_view(),
        name="changefeedentry-list",
    ),
    path(
        "api/changes/<int:pk>",
        views.ChangeFeedEntryDetailView.as_view(),
        name="changefeedentry-detail",
    ),
    path("feed/changes", views.ChangeFeed(), name="changefeed-feed"),
]

fediverser/apps/core/templates/portal/redditor/decline_invite.tmpl.html
{% extends "portal/generic/form.tmpl.html" %}
{% load fediverser %}

{% block before_form %}
{% fediverser_portal_settings as site %}
<p>
  We at {{ site.Portal.name }} are committed to help get people out of legacy social networks and into the <a href="https://fediverse.party" target="_blank">party of the Open Social Web</a>. However, we understand that this might not be for everyone. Please fill in the form below to decline our invite and we will not be sending any more messages.
</p>
{% endblock %}

{% block actions %}
<input type="submit" value="Submit" class="button" />
{% endblock %}

fediverser/apps/core/templates/portal/redditor/detail.tmpl.html
{% extends "portal/base.tmpl.html" %}
{% load humanize fediverser %}

{% block main_header %}
{% include "portal/redditor/header.tmpl.html" with title=page_title subtitle=page_subtitle action_url=header_action_url action_text=header_action_label icon=header_icon redditor=object %}
{% endblock %}


{% block main_content %}
<dl>
  <dt>Reddit Page</dt>
  <dd><a href="{{ object.reddit_view_url }}"}} target="_blank">{{ object }}</a></dd>
  <dt>Joined</dt>
  <dd>{{ object.created|naturaltime }}</dd>
  <dt>Migration status</dt>
  <dd>
    {% if object|has_joined_portal %}
    Migrated
    {% elif object|has_pending_invites %}
    Invite was sent, but has not responded yet.
    {% else %}
    Not migrated.
    {% endif %}
  </dd>
  <dt>Fediverse identities</dt>
  <dd>
    {% for connection in object.connected_activitypub_accounts.all %}
    {{ connection.actor.url }}
    {% empty %}
    No Fediverse identity connected, yet.
    {% endfor %}
  </dd>
</dl>

<hr />

<p>

</p>
{% endblock %}

fediverser/apps/core/templates/portal/redditor/header.tmpl.html
{% extends "portal/partials/header.tmpl.html" %}
{% load wagtailadmin_tags fediverser %}

{% block right_column %}
{% if user.is_authenticated and redditor|should_be_invited %}
<div class="actionbutton">
  {% if user.account.can_send_reddit_private_messages %}
  <form action="{% url 'fediverser-core:redditor-send-invite' redditor.username %}" method="POST" novalidate>
    {% csrf_token %}

    <button class="button bicolor button--icon">
      {% icon name="mail" wrapped=1 %}
      Send Invite to {{ redditor }}
    </button>
  </form>
  {% else %}
  <a class="button bicolor button--icon" href="{% url 'fediverser-core:reddit-connection-setup' %}?scope=privatemessages&next={% url 'fediverser-core:redditor-detail' redditor.username %}">
    {% icon name="mail" wrapped=1 %}
    Send Invite to {{ redditor }}
  </a>
  {% endif %}
</div>
{% endif %}
{% endblock %}

fediverser/apps/core/templates/portal/redditor/list.tmpl.html
{% extends "portal/generic/listing.tmpl.html" %}
{% load humanize %}

{% block listing %}
<table class="listing listing--inline-actions">
  <thead>
    <tr>
      <th scope="col">Name</th>
      <th scope="col">Fediverse Identities</th>
      <th scope="col">Actions</th>
    </tr>
  </thead>
  <tbody>
    {% for redditor in object_list %}
    <tr>
      <td class="title">
        <div class="title-wrapper">
          <a href="{% url 'fediverser-core:redditor-detail' username=redditor.username %}">
            {{ redditor.username }}
          </a>
        </div>
      </td>
      <td>
      </td>
    </tr>
    {% endfor %}
  </tbody>
</table>
{% endblock %}